<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { computed, ref, inject } from 'vue';
import Answer from '@/components/chat/pdf/Answer.vue';
import { useRoute } from 'vue-router';
import { request } from '@/lib/request';

const route = useRoute();
const layout: string = String(route.query.layout ? route.query.layout : 'portrait'); //portrait or landscape
const size: string = String(route.query.size ? route.query.size : 'A4'); //A0 ... A4
const pageOpts = { layout, size };
const chatId = route.params.chatId;
const userId = route.params.user_uuid;
const data = ref();
const configuration = inject<any>('configuration');
const basePath = configuration.basePath;
const headline = ref('');
const url = ref('');
const adminMail = ref('');
const personName = ref('');
const avatar = ref('');
const prompt = ref('');
const description = ref('');

const getBoardData = async () => {
    let requestUrl = configuration.exportApiServer + "/api/ai/chat/" + chatId;
    if(userId)
        requestUrl = requestUrl + "/" + userId;
    else
        requestUrl = requestUrl + "?messages=true";
    let result = await request('GET', requestUrl, undefined, 'application/json', undefined, !userId);
    if (result && result.success) {
        headline.value = result.chat.name;
        adminMail.value = result.chat.user_mail;
        url.value = configuration.baseURL + basePath + (chatId?"chat/":"overview/chat/") +chatId + (userId?"/"+userId:"");
        data.value = result.messages;
        personName.value = result.chat.person_name ?? 'Chatbot';
        avatar.value = result.chat.avatar;
        prompt.value = result.chat.system_prompt;
        description.value = result.chat.person_description;
    }
}

getBoardData();

const generateDate = computed(() => {
    let date = new Date();
    let month = date.getMonth() + 1;
    let day = date.getDate();
    let hours = date.getHours();
    let minutes = date.getMinutes();
    return `${day > 9 ? day : "0" + day}.${month > 9 ? month : "0" + month}.${date.getFullYear()} ${hours > 9 ? hours : "0" + hours}:${minutes > 9 ? minutes : "0" + minutes}`
});

const getBlockHeight = computed(() => {
    let calcHeight = 0;
    switch (pageOpts.size) {
        case "A0":
            if (pageOpts.layout === "landscape") {
                calcHeight = 11 * 82
            }
            else {
                calcHeight = 7 * 116
            }
            break;
        case "A1":
            if (pageOpts.layout === "landscape") {
                calcHeight = 7 * 58
            }
            else {
                calcHeight = 5 * 82
            }
            break;
        case "A2":
            if (pageOpts.layout === "landscape") {
                calcHeight = 5 * 40
            }
            else {
                calcHeight = 3 * 58
            }
            break;
        case "A3":
            if (pageOpts.layout === "landscape") {
                calcHeight = 3 * 28
            }
            else {
                calcHeight = 2 * 40
            }
            break;
        case "A4":
            if (pageOpts.layout === "landscape") {
                calcHeight = 2 * 20
            }
            else {
                calcHeight = 1 * 28
            }
            break;
    }
    return { "height": calcHeight + "cm" };
});

const getAvatarPath = computed(()=>{
    return configuration.exportApiServer + avatar.value;
});

</script>
<template>
    <div id="export" class="h-full text-black">
        <div class="flex flex-row justify-between">
            <a class="h-[1.5cm] w-[1.5cm]" :href="basePath + '/'">
                <img :src="basePath + 'images/logo.png'" class="h-[1.5cm] w-[1.5cm]">
            </a>
            <p class="h-[1.5cm] leading-[1.5cm]">{{ url }}</p>
        </div>
        <div class="mt-[1.5cm]">
            <p>{{ adminMail }}</p>
            <p class="text-2xl">{{ headline }}</p>
            <p class="text-gray-500">{{ generateDate }}</p>
        </div>
        <div style="column-width:9cm;column-fill: auto;">
            <div class="border border-black rounded-md mb-2 p-4 flex flex-col gap-2" v-if="avatar || prompt || description">
                <img class="min-w-8 min-h-8 max-w-8 max-h-8 rounded-full object-contain" :src="getAvatarPath" v-if="avatar"/>
                <div v-if="prompt">
                    <label>{{ $t('ai.chat.create.systemprompt.label') }}</label>
                    <div class="bg-gray-200 font-mono rounded-md p-2">{{ prompt }}</div>
                </div>
                <div v-if="description">
                    <label>{{ $t('ai.person.create.description.label') }}</label>
                    <div v-html="description"></div>
                </div>
            </div>
            <div v-for="element, index in data">
                <Answer class="border border-black rounded-md mb-2" :answer="element" :personName="personName" :userName="adminMail" v-if="(!element.meta || (element.meta && !element.meta.hide))" />
            </div>
            <div class="empty-column block" :style="[getBlockHeight]"></div>
        </div>
    </div>
</template>